# -*- coding: utf-8 -*-


"""
#graphMap

    def generateNodes(self, ind, matching = False):
        if matching:
            nodeList = self.matchingNodeList
            edgeMatrices = self.matchingEdgeMatrices
        else:
            nodeList = self.nodeList
            edgeMatrices = self.edgeMatrices
            
        element = ind.codescriptor()
        for i in nodeList:
            if nodeList[i].sort == element.sort:
                index = nodeList[i].addInstance(element, ind)
                if index is True:
                    edgeMatrices[i].append([None]*len(nodeList[i].individuals))
                    
                    for j in range(len(nodeList[i].individuals)-1):
                        comparand = nodeList[i].individuals[j].codescriptor
                        edge = ANY
                        if comparand.parallel(element):
                            edge = PARALLEL
                        elif comparand.perpendicular(element):
                            edge = PERPENDICULAR
                            
                            
                        positionOne = OUTSIDE
                        positionTwo = OUTSIDE
                        
                        if edge != PARALLEL:
                            intersection = comparand.intersection(element)
                            for k in nodeList[i].individuals[-1].forms:
                                if k.start == intersection or k.end == intersection:
                                    positionOne = BOUND
                                    break
                                elif k.containsPoint(intersection):
                                    positionOne = INSIDE
                                    break
                            for k in nodeList[i].individuals[j].forms:
                                if k.start == intersection or k.end == intersection:
                                    positionTwo = BOUND
                                    break
                                elif k.containsPoint(intersection):
                                    positionTwo = INSIDE
                                    break
                            
                        edgeMatrices[i][j].append([edge, positionOne])
                        edgeMatrices[i][-1][j] = [edge, positionTwo]
                        
                else:
                    for j in range(len(nodeList[i].individuals)):
                        if j == index:
                            continue
                        if edgeMatrices[i][j][index][0] != PARALLEL:
                            
                            positionOne = OUTSIDE
                            positionTwo = OUTSIDE
                            comparand = nodeList[i].individuals[j].codescriptor
                            intersection = comparand.intersection(element)
                            for k in nodeList[i].individuals[index].forms:
                                if k.start == intersection or k.end == intersection:
                                    positionOne = BOUND
                                    break
                                elif k.containsPoint(intersection):
                                    positionOne = INSIDE
                                    break
                            for k in nodeList[i].individuals[j].forms:
                                if k.start == intersection or k.end == intersection:
                                    positionTwo = BOUND
                                    break
                                elif k.containsPoint(intersection):
                                    positionTwo = INSIDE
                                    break
                            
                            edgeMatrices[i][j][index][1] = positionOne
                            edgeMatrices[i][index][j][1] = positionTwo
                            
                return None
                                                            
        node = graphNode(element, ind)
        nodeList[node.sort.name] = node
        edgeMatrices[node.sort.name] = [[None]]
        return node
        
    
    def map(self, fromInd, toInd):
        print('~~~')
        self.generateNodes(toInd, matching = True)
        for i in self.matchingNodeList:
            for j in self.matchingEdgeMatrices[i]:
                for k in j:
                    if k is None:
                        print(NONE, end=' ')
                    else:
                        print (k,end=' ')
                print()
        return True
        
        
    def distinguish(self, ind):
        print()
        print(ind)
        node = self.generateNodes(ind)
        for i in self.nodeList:
            for j in self.edgeMatrices[i]:
                for k in j:
                    if k is None:
                        print(NONE, end=' ')
                    else:
                        print (k,end=' ')
                print()
        return node
        
    def potentialTransforms(self):
        transforms = []
        for sort in self.nodeList:
            if len(self.nodeList[sort]) > len(self.matchingNodeList[sort]):
                return []
            matchLists = []
            self.detectTransform(matchLists, sort)
            for match in matchLists:
                print('\n',match)
                transf = graphTransform()
                check = True
                for i in range(len(self.nodeList[sort])):
                    for j in range(i+1, len(self.nodeList[sort])):
                        if self.edgeMatrices[sort][i][j][0] != PARALLEL:
                            vectFrom = self.nodeList[sort].individuals[i].codescriptor.intersection(self.nodeList[sort].individuals[j].codescriptor)
                            l1 = self.matchingNodeList[sort].individuals[match[i]].codescriptor
                            l2 = self.matchingNodeList[sort].individuals[match[j]].codescriptor
                            vectTo = l1.intersection(l2)
                            print(vectFrom, vectTo)
                            if not transf.add(vectFrom, vectTo):
                                check = False
                                break
                    if not check:
                        break
                if check:
                    transforms.append(transf)
        return transforms


"""